using HermesSocketServer.Models;
using ILogger = Serilog.ILogger;

namespace HermesSocketServer.Requests
{
    public class GetConnections : IRequest
    {
        public string Name => "get_connections";
        public string[] RequiredKeys => [];
        private ILogger _logger;

        public GetConnections(ILogger logger)
        {
            _logger = logger;
        }

        public Task<RequestResult> Grant(Channel channel, IDictionary<string, object> data)
        {
            var connections = channel.Connections.Get().Values;
            _logger.Information($"Fetched all connections for channel [channel: {channel.Id}]");
            return Task.FromResult(RequestResult.Successful(connections, notifyClientsOnAccount: false));
        }
    }
}