using HermesSocketServer.Models;
using ILogger = Serilog.ILogger;

namespace HermesSocketServer.Requests
{
    public class GetGroupPermissions : IRequest
    {
        public string Name => "get_group_permissions";
        public string[] RequiredKeys => [];
        private readonly ILogger _logger;

        public GetGroupPermissions(ILogger logger)
        {
            _logger = logger;
        }

        public Task<RequestResult> Grant(Channel channel, IDictionary<string, object> data)
        {
            var permissions = channel.GroupPermissions.Get().Values;
            _logger.Information($"Fetched all group permissions for channel [channel: {channel.Id}]");
            return Task.FromResult(RequestResult.Successful(permissions, notifyClientsOnAccount: false));
        }
    }
}